<?php
/**
* @copyright Copyright (C) 2006 - 2010 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
* @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/

defined("_JEXEC") or die('Restricted Access');
jimport('joomla.event.plugin');

class plgMassMail_filterJuser extends JPlugin
{

	var $result = array();

	function plgMassMail_FilterJuser(&$subject)
	{
		parent::__construct($subject);


	}


	function onRenderForm($params)
	{

		$params = new JParameter($params);
		$fields =  JuserPluginHelper::getFilterableFieldList();
		return JuserPluginHelper::getFilters($fields, $params->toArray());
	}

	function onCutomJavaScript()
	{
		$text = '
    <script language="javascript">
      function set_all_values( alias, mode )
      {
        i=0;
        while(1){
          field_value = document.getElementById("field_values_"+alias+"_"+i);

          if( field_value.value == "_stop_karaul_ne_mogu_bolshe_" )
          { break;}

          field_value.checked=mode;

          i++;
        }
      }
    </script>
    ';
		return $text;

	}

	function onLeftJoin()
	{
		$post = JRequest::get('POST');
		$this->result = JUserExportHelper::fieldHavingConditions($post);
		return JUserExportHelper::fieldListSubquery($this->result['field_ids']);
	}

	function onBuildWhere()
	{
		$post = JRequest::get('POST');
		$this->result = JUserExportHelper::fieldHavingConditions($post);
		return $this->result['result'];
	}



}

class JuserPluginHelper
{


	function getFilterableFieldList()
	{
		$db = &JFactory::getDBO();
		$include_type_list = array( "select", "checkbox", "radio", "date", "calendar", "phone", "text", "textarea", "mult_select" );
		$include_type_list = " f.type IN('" . implode( "','", $include_type_list ) . "') ";

		$query = "SELECT f. * , f.id as field_id, c.title as cat_title"
		. "\n       FROM #__juser_extended_fields AS f"
		. "\n  LEFT JOIN #__categories            AS c ON c.id = f.catid"
		. "\n      WHERE 1 AND " . $include_type_list
		. "\n   ORDER BY c.ordering, f.ordering"
		;

		$db->setQuery($query);
		$filterable_field_list = $db->loadObjectList();
		return $filterable_field_list;
	}


	function getFilters($fields, $selected = null)
	{
		$result  = array();

		foreach($fields as $key=>$field){
			$text = new stdClass();
			$text->title = $field->title;

			$text->form = '<table class="admintable" width="100%">
					        <tr>
					       <td>'
					       .JuserPluginHelper::fieldValuesFilter($field, $selected).
								'</td>
					        </tr></table>';
       $result[$key] = $text;
		}
		return $result;
	}

	function fieldValuesFilter( $field, $selected=null )
	{
		$toBeSelected = '';

		if (!empty($selected))
		{
			foreach ($selected as $key=>$val)
			{
				/*echo $key;
				//echo str_replace("type", 'condition' , $key);
				echo "<br>";*/
				$sep = explode("::", $key);
				if (preg_match("/::type$/iU", $key) && @$sep[1] == $field->id)
				{
					if (@$selected[$key] == 'select' || @$selected[$key] == 'checkbox' || @$selected[$key] == 'radio' || @$selected[$key] == 'mult_select')
					{
						/*print "<pre>";
						print_r(@$selected[str_replace("type", 'condition' , $key)]);
						print "</pre>";*/
						if (!empty($selected[str_replace("type", 'condition' , $key)]) )
						{

							if (!is_array($selected[str_replace("type", 'condition' , $key)]))
							{
								$toBeSelected = array($selected[str_replace("type", 'condition' , $key)]);
								break;
							}
							else
							{
								$toBeSelected = $selected[str_replace("type", 'condition' , $key)];
								break;
							}

						}

					}
					else if ((@$selected[$key] == 'text' || @$selected[$key] == 'textarea'))
					{

						$toBeSelected = $selected[str_replace("type", 'condition' , $key)];
						break;

					}
					continue;
				}

				if (@$sep[1] == $field->id){
					if (preg_match("/::country$/iU", $key))
					{
						$toBeSelected['country'] = $val;
					}
					else if (preg_match("/::city$/iU", $key))
					{
						$toBeSelected['city'] = $val;
					}
					else if (preg_match("/::phone$/iU", $key))
					{
						$toBeSelected['phone'] = $val;
					}
					else if (preg_match("/::extention$/iU", $key))
					{
						$toBeSelected['extention'] = $val;
					}
					else if(preg_match("/::date_from$/iU", $key))
					{
						$toBeSelected['date_from'] = $val;

					}
					else if(preg_match("/::date_to$/iU", $key))
					{
						$toBeSelected['date_to'] = $val;

					}
				}
			}


		}
		switch($field->type){
			case 'text':
			case 'textarea':
				$result = JuserPluginHelper::textFilter($field, $toBeSelected);
				break;
			case 'date':
			case 'calendar':
				$result = JuserPluginHelper::dateFilter($field, $toBeSelected);
				break;
			case 'select':
			case 'radio':
			case 'mult_select':
			case 'checkbox':
				$result = JuserPluginHelper::multivalueFilter($field, $toBeSelected);
				break;
			case 'phone':
				$result = JuserPluginHelper::phoneFilter($field, $toBeSelected);
				break;
		}

		return $result;
	}

	function textFilter($field, $value=null)
	{
		$result  = '';

		$result .= '<input type="text"   name="value_filter[jufilter::'.$field->field_id.'::condition]" value="'.$value.'">';

		$result .= '<input type="hidden" name="value_filter[jufilter::'.$field->field_id.'::type]" value="'.$field->type.'">';

		return $result;
	}

	function dateFilter($field=null, $value=null)
	{
		$date_from  = '';
		$date_to 		= '';
		if (!empty($value))
		{
			$date_from = @$value['date_from'];
			$date_to = @$value['date_to'];
		}
		$result  = '';
		$result .= '<table><tr><td>';
		$result .= '<small>'.JText::_('From').'</small>';
		$result .= '</td><td>';
		$result .= JHTML::_('calendar', $date_from, 'value_filter[jufilter::'.$field->field_id.'::condition::date_from]', 'id_date_from_'.$field->alias, '%Y-%m-%d', array('class' => 'inputbox'));
		$result .= '</td></tr><tr><td>';
		$result .= '<small>'.JText::_('To').'</small>';
		$result .= '</td><td>';
		$result .= JHTML::_('calendar', $date_to, 'value_filter[jufilter::'.$field->field_id.'::condition::date_to]', 'id_date_to_'.$field->alias, '%Y-%m-%d', array('class' => 'inputbox'));
		$result .= '</td></tr></table>';

		$result .= '<input type="hidden" name="value_filter[jufilter::'.$field->field_id.'::type]" value="'.$field->type.'">';

		return $result;
	}

	function multivalueFilter($field, $values=null)
	{

		$field_values = JuserPluginHelper::getFieldValues($field);

		$result  = '';
		$result .= '<div id="container_'.$field->alias.'" >';
		$result .= '<a href="javascript: void(0);" onclick="set_all_values(\''.$field->alias.'\', true )">';
		$result .= JText::_('Select all');
		$result .= '</a>';
		$result .= ' / ';
		$result .= '<a href="javascript: void(0);" onclick="set_all_values(\''.$field->alias.'\', false )">';
		$result .= JText::_('Deselect all');
		$result .= '</a>';
		$result .= '<hr>';
		$result .= '<table><tr>';
		$column = 1;
		foreach($field_values as $key => $value){
			$checked = @in_array($value, $values) ? 'checked="checked"':'';
			if($column > 2){
				$result .= '</tr><tr>';
				$column = 1;
			}
			$result .= '<td><input type="checkbox" name="value_filter[jufilter::'.$field->field_id.'::condition][]" id="field_values_'.$field->alias.'_'.$key.'" value="'.$value.'" '.$checked.'> '.$value.'</td>';
			$column++;
		}
		//$result .= '<input type="hidden" id="field_values_'.$field->alias.'_'.($key+1).'" value="_stop_karaul_ne_mogu_bolshe_">';
		$result .= '</tr></table>';
		$result .= '</div>';
		$result .= '<input type="hidden" name="value_filter[jufilter::'.$field->field_id.'::type]" value="'.$field->type.'">';

		return $result;
	}

	function phoneFilter($field, $values=null)
	{
		$country = '';
		$city    = '';
		$phone   = '';
		$extention='';
		if (!empty($values))
		{
			$country 	 = @$values['country'];
			$city 		 = @$values['city'];
			$phone 		 = @$values['phone'];
			$extention = @$values['extention'];

		}

		$result = '';
		$result .= '<table><tr><td>';
		$result .= '<small>'.JText::_('Country code').'</small>';
		$result .= '</td><td>';
		$result .= '<small>'.JText::_('City code').'</small>';
		$result .= '</td><td>';
		$result .= '<small>'.JText::_('Phone').'</small>';
		$result .= '</td><td>';
		$result .= '<small>'.JText::_('Extention').'</small>';
		$result .= '</td></tr><tr><td>';
		$result .= '<input type="text" name="value_filter[jufilter::'.$field->field_id.'::condition::country]" size="7" value="'.$country.'"> ';
		$result .= '</td><td>';
		$result .= '<input type="text" name="value_filter[jufilter::'.$field->field_id.'::condition::city]" size="5" value="'.$city.'"> ';
		$result .= '</td><td>';
		$result .= '<input type="text" name="value_filter[jufilter::'.$field->field_id.'::condition::phone]" size="7" value="'.$phone.'"> ';
		$result .= '</td><td>';
		$result .= '<input type="text" name="value_filter[jufilter::'.$field->field_id.'::condition::extention]" size="5" value="'.$extention.'">';
		$result .= '</td></tr></table>';

		$result .= '<input type="hidden" name="value_filter[jufilter::'.$field->field_id.'::type]" value="'.$field->type.'">';

		return $result;
	}

	function getFieldValues($field)
	{
		$db		 = & JFactory::getDBO();

		$query = "SELECT f.params"
		. "\n       FROM #__juser_extended_fields AS f"
		. "\n      WHERE 1 AND f.id = ".$field->field_id
		;
		$db->setQuery($query);
		$params_str = $db->loadResult();

		$params = new JParameter( $params_str );

		$field_value_list = $params->get('values');
		if($field_value_list){
			$field_value_list = explode( "\n", str_replace( "\r", "", $field_value_list ) );

			sort($field_value_list);
		} else {
			return array();
		}
		return $field_value_list;
	}
}


class JUserExportHelper
{

	function fieldHavingConditions( &$post )
	{
		$fields = array();
		$result = array();
		$field_ids = array();

		if (count(@$post['value_filter'])<1){$post['value_filter']=array();}
		$value_filter = @$post['value_filter'];
		foreach($value_filter as $key => $field){
			$name = explode("::",$key);
			$id = intval(@$name[1]);
			if (in_array($id, $field_ids))
			{
				continue;
			}
			//if (!isset($field['type'])){continue;}
			switch(trim(@$value_filter['jufilter::'.$id.'::type'])){
				case 'date':
				case 'calendar':
					if(isset($value_filter['jufilter::'.$id.'::condition::date_from']) && $value_filter['jufilter::'.$id.'::condition::date_from']){
						$result[] = "( jed".$name[1].".fvalue >= '".$value_filter['jufilter::'.$name[1].'::condition::date_from']."' )";
						if (!in_array($id, $field_ids))
						{
							$field_ids[] = $id;
						}
					}
					if(isset($value_filter['jufilter::'.$id.'::condition::date_to']) && $value_filter['jufilter::'.$id.'::condition::date_to']){
						$result[] = " ( jed".$id.".fvalue <= '".$value_filter['jufilter::'.$id.'::condition::date_to']."' ) ";
						if (!in_array($id, $field_ids))
						{
							$field_ids[] = $id;
						}
					}
					break;
				case'text':
				case'textarea':
					if(isset($value_filter['jufilter::'.$id.'::condition']) && $value_filter['jufilter::'.$id.'::condition']){
						$result[] = "jed".$id.".fvalue like '%".$value_filter['jufilter::'.$id.'::condition']."%'";
						if (!in_array($id, $field_ids))
						{
							$field_ids[] = $id;
						}
					}
					break;
				case'radio':
				case'select':
					if(isset($value_filter['jufilter::'.$id.'::condition']) && count( $value_filter['jufilter::'.$id.'::condition'])){
						$result[] = "('".implode("' =  jed$id.fvalue OR '", $value_filter['jufilter::'.$id.'::condition'])."' =  jed$id.fvalue)";
						if (!in_array($id, $field_ids))
						{
							$field_ids[] = $id;
						}
					}
					break;
				case 'mult_select':
				case 'checkbox':
					if(isset($value_filter['jufilter::'.$id.'::condition']) && count( $value_filter['jufilter::'.$id.'::condition'] )){
						$result[] =  "( concat('\n',jed$id.fvalue,'\n') like '%\n".implode("\n%' OR concat('\n',jed$id.fvalue,'\n') like '%\n", $value_filter['jufilter::'.$id.'::condition'])."\n%' )";
						if (!in_array($id, $field_ids))
						{
							$field_ids[] = $id;
						}
					}
					break;
				case 'phone':

					$sub_result = array();
					if(isset($value_filter['jufilter::'.$id.'::condition::country']) && $value_filter['jufilter::'.$id.'::condition::country']){
						$value_filter['jufilter::'.$id.'::condition::country'] = preg_replace('/\s|\+|\#|\-/',"", $value_filter['jufilter::'.$id.'::condition::country']);
						$sub_result[] = "^".$value_filter['jufilter::'.$id.'::condition::country']."\n(.*)\n(.*)\n(.*)$";
					}
					if(isset($value_filter['jufilter::'.$id.'::condition::city']) && $value_filter['jufilter::'.$id.'::condition::city']){
						$value_filter['jufilter::'.$id.'::condition::city'] = preg_replace('/\s|\+|\#|\-/',"", $value_filter['jufilter::'.$id.'::condition::city']);
						$sub_result[] = "^(.*)\n".$value_filter['jufilter::'.$id.'::condition::city']."\n(.*)\n(.*)$";
					}
					if(isset($value_filter['jufilter::'.$id.'::condition::phone']) && $value_filter['jufilter::'.$id.'::condition::phone']){
						$value_filter['jufilter::'.$id.'::condition::phone'] = preg_replace('/\s|\+|\#|\-/',"", $value_filter['jufilter::'.$id.'::condition::phone']);
						$sub_result[] = "^(.*)\n(.*)\n".$value_filter['jufilter::'.$id.'::condition::phone']."\n(.*)$";
					}
					if(isset($value_filter['jufilter::'.$id.'::condition::extention']) && $value_filter['jufilter::'.$id.'::condition::extention']){
						$value_filter['jufilter::'.$id.'::condition::extention'] = preg_replace('/\s|\+|\#|\-/',"", $value_filter['jufilter::'.$id.'::condition::extention']);
						$sub_result[] = "^(.*)\n(.*)\n(.*)\n".$value_filter['jufilter::'.$id.'::condition::extention']."$";
					}

					if(count($sub_result)){
						$result[] = " (jed".$id.".fvalue REGEXP '".implode("' OR jed".$id.".fvalue REGEXP '",$sub_result)."')";
						if (!in_array($id, $field_ids))
						{
							$field_ids[] = $id;
						}
					}
					break;
			}
		}

		//$result = implode($result, " AND ");
		/*if($result){
		$result = ' AND '.$result;
		}*/
		$return['result']   = $result;
		$return['field_ids'] = $field_ids;
		return $return;
	}

	function fieldListSubquery($ids)
	{

		$result = array();
		ksort($ids);
		foreach($ids  as $field){
			$result[] = " LEFT JOIN #__juser_extended_data AS jed{$field} ON jed{$field}.user_id = u.id AND jed{$field}.field_id={$field}";


		}
		if (count($result)>0)
		{
			return " ".implode( "\n", $result);
		}
	}
}
?>